
// A program that can help the user balance a checking account.

public class BalanceAccountConsole extends ConsoleApplet {

   protected String getTitle() {
      return "Bank Account Test";
   }

   protected void program() {
   
      Account account;  // An object representing the bank account.
      boolean done;     // Flag for checking whether user wants to quit.
      int choice;       // Number of user's choice from a menu.
      double amount;    // An amount read from the user, used for various purposes.
      double rate;      // An interest rate entered by the user.
   
      console.putln();
      console.putln();
      console.putln("This program will help you balance your checking account.");
      console.putln();
      console.putln("Please enter the opening balance in your account.");
      console.putln();
      console.put("? ");
      amount = console.getlnDouble();
      
      account = new Account(amount);      
      
      console.putln();
      console.putln("Now use the following menu to record your deposits,");
      console.putln("withdrawals, and interest and to see your balance:");
      console.putln("");
   
      done = false;
   
      while (!done) {
      
         console.putln();
         console.putln();
         console.putln("Choose one of the following options:");
         console.putln();
         console.putln("   1.  Make a deposit.");
         console.putln("   2.  Make a withdrawal.");
         console.putln("   3.  Add interest.");
         console.putln("   4.  See the balance.");
         console.putln("   5.  Exit from this program.");
         console.putln();
         console.put("Enter the number of your choice:  ");
         
         switch ( console.getlnInt() ) {
            case 1:
               console.put("Enter the amount of the deposit:  $");
               amount = console.getlnDouble();
               account.deposit(amount);
               break;
            case 2:
               console.put("Enter the amount of the withdrawal:  $");
               amount = console.getlnDouble();
               account.withdraw(amount);
               break;
            case 3:
               console.putln("Please enter the interest rate as a decimal,");
               console.putln("for example:  0.05  rather than  5%");
               console.putln();
               console.put("Enter the interest rate:  ");
               rate = console.getlnDouble();
               account.addInterest(rate);
               break;
            case 4:
               amount = account.getBalance();
               console.putln();
               console.putln("*** Your balance is  $" + amount);
               if (amount < 0)
                  console.putln("*** Warning: you are overdrawn!!");
               break;
            case 5:
               done = true;
               break;
            default:
               console.putln();
               console.putln("Illegal option.  Try again!");
               break;
         }
         
      } // end while
   
   } // end main

} // end class BalanceAccount
