/*
 *  This program lets the user play one game of "hangman".
 *  The user tries to guess letters in a secret word.  The
 *  word is chosen randomly by the computer form a short
 *  list of words. (The program needs to be improved so that
 *  it can choose words from a much longer list.)
 *     The program ends when the user has guessed all the
 *  letters in the word, or when the user has guessed six
 *  letters that don't occur in the word.
 */
 
public class Hangman {

   public static void main(String[] args) {
   
      String word;  // The word that the user tries to guess.
      char guess;   // A lowercase letter guessed by the user.
      String used;  // All the letters that the user has guessed.
      int wrongCt;  // Number of wrong guesses that the user made.
      int i;        // For use as a for loop variable.
      
      System.out.println("\nLet's play a game of Hangman.  I will pick a word.");
      System.out.println("You try to gusess letters in the word.  If you make");
      System.out.println("six bad guesses, you lose.  If you get all the");
      System.out.println("letters in the word before you make six bad quesses");
      System.out.println("then you win.\n");

      // First, pick the word at random.  Base the choice on a
      // randomly chosen integer between 0 and 9.  (The formula
      // (int)(10*Math.random()) represents such a number.)
      
      switch ( (int)(10*Math.random()) ) {
         case 0:  word = "smooth";       break;
         case 1:  word = "figment";      break;
         case 2:  word = "telescope";    break;
         case 3:  word = "conventional"; break;
         case 4:  word = "weather";      break;
         case 5:  word = "acrimonious";  break;
         case 6:  word = "ocean";        break;
         case 7:  word = "temporary";    break;
         case 8:  word = "bookmark";     break;
         default: word = "algebra";      break;
      }
      
      used = "";    // User hasn't used any letters yet.
      wrongCt = 0;  // User didn't make any bad guesses yet.
      
      // Use a while loop that gets one letter from the user and
      // processes it.  The loop will end when the game is over.
      
      while (true) {
      
         // Display word, with unguessed letters represented by '_'.
         
         System.out.print("\n\nThe word looks like:   ");
         for (i = 0; i < word.length(); i++) {
            if ( used.indexOf(word.charAt(i)) >= 0 ) {
               // i-th char in word is in the list of used letters.
               System.out.print(word.charAt(i) + " ");
            }
            else {
               // i-th char is not yet guessed; show a '-'.
               System.out.print("_ ");
            }
         }
         System.out.println();
         System.out.println();
         
         // If any letters have been guessed by the user, show them.
         
         if (used.length() > 0) {
            System.out.println("Letters guessed so far:   " + used);
         }
         
         // Tell user how many bad guesses still remain.
         
         System.out.println("You have " + (6-wrongCt)
                                   + " incorrect guesses left.");
      
         // Get lower case letter, in the range 'a' to 'z', from user.
         
         System.out.print("\nEnter a letter:  ");
         do {
            guess = TextIO.getChar();
            if (guess < 'a' || guess > 'z')
               System.out.println("You must enter a lower-case letter:  ");
         } while (guess < 'a' || guess > 'z');
         
         // Process the user's guess.
         
         if ( used.indexOf(guess) >= 0 ) {
            // The user's letter is already in the list of used letters.
            System.out.println("You already guessed " + guess 
                                                   + "!  Try again.");
         }
         else if ( word.indexOf(guess) < 0  ) {
            // The guessed letter does not occur in the word.
            // The number of bad guesses goes up by one.
            // The game will end if the number of wrong guesses is 6.
            wrongCt++;
            System.out.println("\nSorry, " + guess + " is not in my word.");
            used += guess;  // Add guess onto the list of used letters.
            if (wrongCt == 6) {
               System.out.println("That was you last chance.  You're hung!");
               System.out.println("The word was \"" + word + "\".");
               break;
            }
         }
         else {
            // The guessed letter is in the word.  Game ends if all
            // the letters in the word have been guessed.
            System.out.println("\nYes, " + guess + " occurs in my word.");
            used += guess;  // Add guess onto the list of used letters.
            int ct; // For counting the number of guessed letters in word
            ct = 0;
            for (i = 0; i < word.length(); i++) {
               if ( used.indexOf(word.charAt(i)) >= 0 )
                 ct++;
            }
            if ( ct == word.length() ) {
               // Every letter in word was found in the list of used letters.
               System.out.println("You got it!  The word was \"" + word + "\".");
               break;
            }
         }
         
      } // end while
      
      
      System.out.println("\nThanks for playing!\n");
   
   } // end main()
   
} // end class Hangman
