public class Birthday {

   public static void main(String[] args) {
   
      System.out.println("Suppose you ask N people to tell you their birthdays.");
      System.out.println("What is the chance that there are two people in the");
      System.out.println("group who have the same birthday, that is they were");
      System.out.println("born on the same month and day but not necessarily in");
      System.out.println("the same year?");
      System.out.println("   This program can compute the mathematical probability");
      System.out.println("for you.  It can also run a simulation of the experiment");
      System.out.println("and it can the experiment a large number of times to");
      System.out.println("verify the probability experimentally.");
      System.out.println("   For the purposes of this program, we will assume that");
      System.out.println("that there are 365 days in the year.");
      
      mainloop:  while (true) {
          System.out.println("\n\nMENU:");    
          System.out.println("   1.  Compute the odds.");    
          System.out.println("   2.  Simulate one experiment.");    
          System.out.println("   3.  Simulate many experiments.");    
          System.out.println("   4.  Exit.");    
          System.out.print("\nEnter the number of your choice:  ");
          switch ( TextIO.getlnInt() ) {
             case 1: 
                computeOdds();
                break;
             case 2: 
                runOneExperiment();
                break;
             case 3:
                runExperiments();
                break;
             case 4:
                break mainloop;
             default:
                System.out.println("\nILLEGAL CHOICE.  Please try again.\n");
          }
      } // end mainloop
      
      System.out.println("\n\nExiting program.\n\n");
   
   } // end main()
   
   
   static void computeOdds() {
       System.out.println("Tell me the number of people, and I will compute the probablility");
       System.out.println("that there are are two people in the group who have the same");
       System.out.println("birthday.");
       System.out.println("\nWhat is the number of people?  ");
       int N = TextIO.getlnInt();
       if (N <= 1)
          System.out.println("Duh...  The probability is zero.");
       else {
          double q = 1;
          for (int i = 1; i < N; i++)
             q = q * ( (365-i) / 365.0 );
          double p = 1 - q;
          System.out.println("\nThe probability that " + N
                                    + " all have different birthdays is " + q);
          System.out.println("This is equal to: 1 * (364/365) * (363/365) * ... * ((365-(N-1))/365)");
          System.out.println("\nThe probability that at least two have the same birthday is " + p);
          System.out.println("This is 1 minus the probability that all birthdays are different.");
       }
   } // end computeOdds()
   
   
   static void runOneExperiment() {
       System.out.println("Tell me the number of people, and I will simulate the process of");
       System.out.println("checking their birthdays and finding out if two of the birthdays");
       System.out.println("are the same.  This will be done by generating N random numbers");
       System.out.println("between 0 and 364 representing days of the year.");
       System.out.println("\nWhat is the number of people?  ");
       int N = TextIO.getlnInt();
       if (N <= 0)
          System.out.println("Duh...  The probability is zero.  Not much of an experiment.");
       else {
          int birthdays = 0;  // Number of different birthdays found.
          boolean[] alreadyUsed = new boolean[365];
          boolean duplicate = false;
          System.out.println("\nHere are the birthdays:\n");
          for (int i = 1; i <= N; i++) {
              int day = (int)(365*Math.random());
              TextIO.put(day,4);
              if (alreadyUsed[day]) {
                 duplicate = true;
                 System.out.print("*");
              }
              else {
                 birthdays++;
                 alreadyUsed[day] = true;
                 System.out.print(" ");
              }
              if (i % 15 == 0 || i == N)
                 System.out.println();
          }
          if (duplicate)
             System.out.println("\nA duplicate was found.  There were " + birthdays +
                                   " different birthdays in the group.");
          else
             System.out.println("\nThere were no duplicate birthdays in the group.");
       }
   } // end runOneExperiment()
   
   
   static void runExperiments() {
       System.out.println("Tell me the number of people, and I will simulate the following");
       System.out.println("experiment repeatedly:  Take a group of N people and determine");
       System.out.println("whether there are two people in the group who share a birthday.");
       System.out.println("I will tell you the number of times a duplicate is found.");
       System.out.println("\nWhat is the number of people?  ");
       int N = TextIO.getlnInt();
       System.out.println("\nHow many times should the experiment be run?");
       int experiments = TextIO.getlnInt();
       if (N <= 0)
          System.out.println("Duh...  The probability is zero.  Not much of an experiment.");
       else if (experiments <= 0)
          System.out.println("The number of experiments has to be greater than zero.");
       else {
          int duppCt = 0; // number of experiments in which a duplicate is found
          for (int exp = 0; exp < experiments; exp++) {
             boolean[] alreadyUsed = new boolean[365];
             for (int i = 0; i < N; i++) {
                int day = (int)(365*Math.random());
                if (alreadyUsed[day]) {
                   duppCt++;
                   break;
                }
                else {
                   alreadyUsed[day] = true;
                }
             }
          }
          System.out.println("\nDuplicates were found in " + duppCt + " experiments.");
          System.out.println("The fraction of experiments in which a duplicate occurred was "
                                    + ( (double)duppCt / experiments ) );
       }
   } // end runExperiments()


} // end class Birthday
